/*
 * Placeholder for Mozilla Tri-licence: MPL/GPL/LGPL
 * Original code from firefox trunk and seamonkey trunk
*/

function xsbInitPageInfo() {
  if (!top.document.getElementById('sidebar-box')) {
    return;
  }
  onLoadPageInfo = function onLoadPageInfo() {

    //dump("===============================================================================\n");

    theBundle = document.getElementById("pageinfobundle");
    gStrings.unknown = theBundle.getString("unknown");
    gStrings.notSet = theBundle.getString("notset");
    gStrings.emptyString = theBundle.getString("emptystring");
    gStrings.noExpiration = theBundle.getString("generalNoExpiration");
    gStrings.linkAnchor = theBundle.getString("linkAnchor");
    gStrings.linkArea = theBundle.getString("linkArea");
    gStrings.linkSubmit = theBundle.getString("linkSubmit");
    gStrings.linkSubmission = theBundle.getString("linkSubmission");
    gStrings.linkRel = theBundle.getString("linkRel");
    gStrings.linkStylesheet = theBundle.getString("linkStylesheet");
    gStrings.linkRev = theBundle.getString("linkRev");
    gStrings.linkX = theBundle.getString("linkX");
    gStrings.mediaImg = theBundle.getString("mediaImg");
    gStrings.mediaBGImg = theBundle.getString("mediaBGImg");
    gStrings.mediaApplet = theBundle.getString("mediaApplet");
    gStrings.mediaObject = theBundle.getString("mediaObject");
    gStrings.mediaEmbed = theBundle.getString("mediaEmbed");
    gStrings.mediaLink = theBundle.getString("mediaLink");
    gStrings.mediaInput = theBundle.getString("mediaInput");
  
    var docTitle = theBundle.getString("pageInfo.title");
    theWindow = content.window;
    theDocument = content.document;

    document.title = docTitle;
  
    // do the easy stuff first
    makeGeneralTab();
  
    // and then the hard stuff
    makeTabs(theDocument, theWindow);
  
    /* Call registered overlay init functions */
    for (x in onLoadRegistry)
    {
      onLoadRegistry[x]();
    }
  
    var tabControl = document.getElementById("tabbox");
    if (tabControl)
    {
      /* Select the requested tab, if the name is specified */
      if ("arguments" in window && window.arguments.length >= 1 &&
          window.arguments[0] && window.arguments[0].initialTab)
      {
        var tab = document.getElementById(window.arguments[0].initialTab);
        if (tab)
          tabControl.selectedTab = tab;
      }
      tabControl.selectedTab.focus();
    }
  }
}

function xsbInitPki() {
  if (!top.document.getElementById('sidebar-box')) {
    return;
  }

  security.viewCert = function () {
        var cert = security._cert;
        viewCertHelper(content.window, cert);
  }

  security._getSecurityInfo = function () {
        const nsIX509Cert = Components.interfaces.nsIX509Cert;
        const nsIX509CertDB = Components.interfaces.nsIX509CertDB;
        const nsX509CertDB = "@mozilla.org/security/x509certdb;1";
        const nsISSLStatusProvider = Components.interfaces.nsISSLStatusProvider;
        const nsISSLStatus = Components.interfaces.nsISSLStatus;

        // Get the window for this information
        var w = content.window;

        var hName = null;
        try
        {
           hName = w.location.host;
        } catch(exception){}

        var ui = security._getSecurityUI();
        var status = null;
        var sp = null;
        var isBroken = false;
        if (ui) {
          isBroken = (ui.state == Components.interfaces.nsIWebProgressListener.STATE_IS_BROKEN);
          sp = ui.QueryInterface(nsISSLStatusProvider);
          if (sp)
            status = sp.SSLStatus;
        }
        if (status) {
          status = status.QueryInterface(nsISSLStatus);
        }
        if (status) {
          var cert = status.serverCert;
          var issuerName;

          issuerName = this.mapIssuerOrganization(cert.issuerOrganization);
          if (!issuerName) issuerName = cert.issuerName;
        
          return {
            hostName : hName,
            cAName : issuerName,
            encryptionAlgorithm : status.cipherName,
            encryptionStrength : status.secretKeyLength,
            isBroken : isBroken,
            cert : cert
          };
        } else {
          return {
            hostName : hName,
            cAName : "",
            encryptionAlgorithm : "",
            encryptionStrength : 0,
            isBroken : isBroken,
            cert : null
          };
        } 
  }

  security._getSecurityUI = function () {
        if ("gBrowser" in top)
          return top.gBrowser.securityUI;
        return null;
  }
}

function xsbInitP3p() {
  if (!top.document.getElementById('sidebar-box')) {
    return;
  }
  initTopDocAndWin = function initTopDocAndWin() {
    gTopWin = content.window;
    gTopDoc = content.document;
  }
}

function xsbInitP3pSummary() {
  if (!top.document.getElementById('sidebar-box')) {
    return;
  }
  getBrowser = function getBrowser() {
    if (!gBrowser)
      gBrowser = top.document.getElementById("content");
    return gBrowser;
  }
}

var xsbPiUtils = {

  advanceSelectedTab : function (event, dir) {
    if (event.button == 0) {
      document.getElementById('tabs').advanceSelectedTab(dir);
      event.stopPropagation();
    }
  },


  createTabPickContext : function (event) {
    const XUL_NAMESPACE = "http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul";

    var popup = event.target;
    // clear out the old context menu contents (if any)
    while (popup.hasChildNodes()) 
      popup.removeChild(popup.firstChild);

    var xNode = document.createElementNS(XUL_NAMESPACE, "menuitem");
    xNode.setAttribute("autoCheck", "false");
    xNode.setAttribute("type",      "checkbox");
    xNode.setAttribute("group",     "pageinfo-tabpick");

    var tabs = document.getElementById("tabs").childNodes;
    var mNode;

    for (var i = 0; i < tabs.length; i++) {
      mNode = xNode.cloneNode(true);      
      mNode.label = tabs[i].label;
      mNode.setAttribute("tabindex", i);
      mNode.setAttribute("oncommand", "xsbPiUtils.pickTab(event)");
      if (tabs[i].selected) {
        mNode.setAttribute("checked", "true");
      }
      popup.appendChild(mNode);
    }
  },

  pickTab : function (event) {
    var tabs = document.getElementById("tabs");
    tabs.selectedIndex = event.target.getAttribute("tabindex");
    event.stopPropagation();
  }
}